-------------------------------------------------------------------------------
-- B3dPipeline.mcr
-- B3dPipeline MacroScripts Include File
-- By Alex Chouls (pudding@onigirl.com)
-- 9/06/03
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------

--callbacks.addScript #filePreOpen "print 'PreOpen'" id:#B3dResetWorkingDir

MacroScript B3dHelp 
category:"B3dPipeline Tools" 
buttontext:"B3d Help" 
tooltip:"B3d Help"
Icon:#("B3dPipeline",1)
(
	helpPath = GetDir #help
	helpFile = helpPath +"\B3dPipelineHelp.chm"
	ShellLaunch helpFile ""
)

MacroScript B3dExport 
category:"B3dPipeline Tools" 
buttontext:"B3d Export" 
tooltip:"B3d Export"
Icon:#("B3dPipeline",2)
(
	b3d_export()
)
	
MacroScript B3dViewer 
category:"B3dPipeline Tools" 
buttontext:"B3d Viewer" 
tooltip:"B3d Viewer"
Icon:#("B3dPipeline",4)
(
	Include "$scripts/B3dPipeline/b3dviewer.ms"
)

MacroScript B3dConfig 
category:"B3dPipeline Tools" 
buttontext:"B3d Viewer Config" 
tooltip:"B3d Viewer Config"
Icon:#("B3dPipeline",5)
(
	Include "$scripts/B3dPipeline/b3dconfig.ms"
)

MacroScript B3dViewerSettings 
category:"B3dPipeline Tools" 
buttontext:"B3d Viewer Export Settings" 
tooltip:"B3d Viewer Export Settings"
Icon:#("B3dPipeline",6)
(
	b3d_export "config" "viewer"
)

MacroScript B3dQuickExport 
category:"B3dPipeline Tools" 
buttontext:"B3d Quick Export" 
tooltip:"B3d Quick Export"
Icon:#("B3dPipeline",7)
(
	b3d_export "quick"
	--setSaveRequired True
)

MacroScript B3dQuickSettings 
category:"B3dPipeline Tools" 
buttontext:"B3d Quick Export Settings" 
tooltip:"B3d Quick Export Settings"
Icon:#("B3dPipeline",8)
(
	b3d_export "config" "quick"
	--setSaveRequired True
)


MacroScript B3dExportLast 
category:"B3dPipeline Tools" 
buttontext:"B3d Export Last" 
tooltip:"B3d Export Last"
Icon:#("B3dPipeline",9)
(
	b3d_export "last"
)

MacroScript B3dBatchExport 
category:"B3dPipeline Tools" 
buttontext:"B3d Batch Export" 
tooltip:"B3d Batch Export"
Icon:#("B3dPipeline",10)
(
	Include "$scripts/B3dPipeline/b3dbatchexport.ms"
)

MacroScript B3dConvertMtls
category:"B3dPipeline Tools" 
buttontext:"B3d Convert Scene Materials" 
tooltip:"B3d Convert Scene Materials"
Icon:#("B3dPipeline",12)
(
	Include "$scripts/B3dPipeline/B3dMaterialUtils.ms"	
	if (queryBox "Convert All Scene Materials to B3d Brush/Map?") then
	(
		convertSceneMtlsToB3d()
	)
)

MacroScript B3dConvertMtlSlot
category:"B3dPipeline Tools" 
buttontext:"B3d Convert Material" 
tooltip:"B3d Convert Material"
Icon:#("B3dPipeline",13)
(
	Include "$scripts/B3dPipeline/b3dMaterialUtils.ms"
	convertMeditSlotToB3d(medit.GetActiveMtlSlot())
)


