-- B3d Pipeline v0.72
-- copyright 2004, Alex Chouls

plugin material B3dBrush
	name:"Blitz3D Brush" 
	classID:#(0x1f127a4d, 0x5ccfc8e5) --genClasID()
	extends:Standardmaterial
	replaceUI:true
( 

---------------------------------------
--paramblocks
---------------------------------------

	parameters main rollout:params 
	(
		color type:#color default:white animatable:true ui:color
		alpha type:#float default:100 ui:alpha animatable:true
		shine type:#float default:0 ui:shine animatable:true
		blend type:#integer default:1 ui:blend animatable:false
		fullbright type:#boolean default:false ui:fullbright animatable:false
		twosided type:#boolean default:false ui:twosided animatable:false
		flatshaded type:#boolean default:false ui:flatshaded animatable:false
		nofog type:#boolean default:false ui:nofog animatable:false
		vertexcolors type:#boolean default:false ui:vertexcolors animatable:false
		vertexalpha type:#boolean default:false ui:vertexalpha animatable:false

		map1 type:#texturemap ui:map1
		map2 type:#texturemap ui:map2
		map3 type:#texturemap ui:map3
		map4 type:#texturemap ui:map4
		map5 type:#texturemap ui:map5
		map6 type:#texturemap ui:map6
		map7 type:#texturemap ui:map7
		map8 type:#texturemap ui:map8

		on1 type:#boolean ui:on1 default:true animatable:false
		on2 type:#boolean ui:on2 default:true animatable:false
		on3 type:#boolean ui:on3 default:true animatable:false
		on4 type:#boolean ui:on4 default:true animatable:false
		on5 type:#boolean ui:on5 default:true animatable:false
		on6 type:#boolean ui:on6 default:true animatable:false
		on7 type:#boolean ui:on7 default:true animatable:false
		on8 type:#boolean ui:on8 default:true animatable:false


		on color set val do delegate.diffuse_color = val 
		on alpha set val do delegate.opacity = val
		on shine set val do delegate.specularLevel = val
		on fullbright set val do
		(
			if (val) then delegate.selfIllumAmount = 100
			else delegate.selfIllumAmount = 0
		)
		on twosided set val do delegate.twoSided = val
		on flatshaded set val do delegate.faceted = val
		
		on map1 set val do if(on1) then delegate.diffuseMap = val
		on map2 set val do delegate.maps[13] = val
		on map3 set val do delegate.maps[14] = val
		on map4 set val do delegate.maps[15] = val
		on map5 set val do delegate.maps[16] = val
		on map6 set val do delegate.maps[17] = val
		on map7 set val do delegate.maps[18] = val
		on map8 set val do delegate.maps[19] = val
	)
	
---------------------------------------
--rollouts
--------------------------------------

	rollout params "Blitz3d Brush" 
	( 

		groupBox grp_blend "Blend" pos:[8,86] width:88 height:94
		radioButtons blend "" pos:[25,110] width:58 height:48 labels:#("Alpha", "Multiply", "Add") default:1 columns:1
		groupBox grp_flags "Flags" pos:[104,86] width:216 height:94
		checkbox fullbright "Full Bright" pos:[117,105] width:77 height:19
		checkbox vertexcolors "Vertex Colors" pos:[117,149] width:85 height:19
		checkbox vertexalpha "Vertex Alpha" pos:[212,149] width:85 height:19
		checkbox flatshaded "Flat Shaded" pos:[117,127] width:77 height:19
		checkbox nofog "Disable Fog" pos:[212,127] width:91 height:19
		checkbox twosided "2-Sided" pos:[212,105] width:77 height:19
		
		groupBox grp1 "" pos:[8,6] width:312 height:71
		label lbl_color "Color:" pos:[18,26] width:32 height:18
		colorpicker color "" pos:[48,23] width:60 height:43 color:[255,255,255] modal:false
		spinner alpha "Alpha: " type:#integer pos:[152,26] width:55 height:16 range:[0,100,100]
		spinner shine "Shine: " type:#integer pos:[152,50] width:55 height:16 range:[0,100,0]
		
		groupBox grp_textures "Texture Layers" pos:[9,189] width:311 height:245
		--spinner layers "Layers:" type:#integer pos:[51,188] width:51 height:16 range:[1,8,1]
		label lbl_on "On/Off" pos:[282,200] width:36 height:19
		label lbl_1 "1: " pos:[23,222] width:15 height:18
		label lbl_2 "2:" pos:[23,247] width:15 height:18
		label lbl_3 "3:" pos:[23,272] width:15 height:18
		label lbl_4 "4:" pos:[23,297] width:15 height:18
		label lbl_5 "5:" pos:[23,322] width:15 height:18
		label lbl_6 "6:" pos:[23,347] width:13 height:18
		label lbl_7 "7:" pos:[23,373] width:15 height:18
		label lbl_8 "8:" pos:[23,398] width:15 height:18
		mapButton map1 "None" pos:[37,218] width:249 height:20
		mapButton map2 "None" pos:[37,243] width:249 height:20
		mapButton map3 "None" pos:[37,268] width:249 height:20
		mapButton map4 "None" pos:[37,293] width:249 height:20
		mapButton map5 "None" pos:[37,318] width:249 height:20
		mapButton map6 "None" pos:[37,343] width:249 height:20
		mapButton map7 "None" pos:[37,369] width:249 height:20
		mapButton map8 "None" pos:[37,394] width:249 height:20
		checkbox on1 "" pos:[294,219] width:20 height:20 default:true
		checkbox on2 "" pos:[294,244] width:20 height:20
		checkbox on3 "" pos:[294,269] width:20 height:20
		checkbox on4 "" pos:[294,294] width:20 height:20
		checkbox on5 "" pos:[294,319] width:20 height:20
		checkbox on6 "" pos:[294,344] width:20 height:20
		checkbox on7 "" pos:[294,370] width:20 height:20
		checkbox on8 "" pos:[294,395] width:20 height:20

		button btn_curves "Edit Curves" pos:[235,48] width:74 height:20 toolTip:""
		
		on btn_curves pressed do
		(
			i = medit.getActiveMtlSlot()

			title = (medit.getcurmtl()).name
			title += " Curves  "

			title += "[ Slot " + i as string
			--title += " : " 
			--title += (medit.getTopMtlSlot(i)).name
			title += " ]"
			--print title
			
			-- Close it if it already exists
			for t in 1 to Trackview.NumTrackViews() do
				(
				--If Trackview.GetTrackviewName T == "B3dMap Curves" then 
				If Trackview.GetTrackviewName T == title then 
					(
						--trackviews.close "B3dMap Curves"
					)
				else 
					(
					)
				)
			-- Make a new one
			TrackView.Open title
			TrackView.setFilter title #all
			TrackView.clearFilter title #modifiedObjects #selectedTracks #visibleObjects #SelectedObjects #animatedTracks --#curveX #curveY #curveZ #Objects #Hierarchy #Transforms #Position #Rotation #Scale #positionX #positionY #positionZ #rotationX #rotationY #rotationZ #scaleX #scaleY #scaleZ
			
			trackviews.currentTrackView.rootTrack = medit.getcurmtl()
			trackviews.currentTrackView.zoomOnTrack trackViewNodes 1
			trackviews.currentTrackView.expandTracks()
			
			-- Now put it into fcurve mode
			tvInterface = trackviews.getTrackView title;
			tvInterface.setEditMode #editFCurves;
			
			-- And select ALL the tracks of the type that we would want to see or select...
			if selection.count != 0 then  (
				numT = tvInterface.getNumTracks()
				didSelect = false;		-- have we done anything yet?
				for t in 1 to numT do (
					myTrack = tvInterface.getTrack t;
					theClass = classOf myTrack;
					if (theClass == Linear_Position or 	theClass == Noise_Position or 	
						theClass == Position_Reactor or theClass == TCB_Position or 	
						theClass == Bezier_Position or theClass == Bezier_Color or 
				
						theClass == Linear_Rotation or	theClass == Noise_Rotation or 	
						theClass == Rotation_Reactor or	theClass == TCB_Rotation or 
						
						theClass == Bezier_Scale or		theClass == Linear_Scale or
						theClass == Noise_Scale or 		theClass == Scale_Reactor or
						theClass == TCB_Scale or
						
						theClass == Bezier_Float or 	theClass == Float_Reactor or
						theClass == Linear_Float or 	theClass == Noise_Float or
						theClass == On_Off or 			theClass == TCB_Float or
						theClass == Waveform_Float	) then (
				
							tvInterface.selectTrackByIndex t (not didSelect);
							didSelect = true;
							)
							
					)
				)
			
		)
	)--end rollout 

	rollout aboutme "About" rolledUp:true
	(
		label info1 "Blitz3d Material"
		label version "B3d Pipeline v0.72"
		label info2 "Copyright 2003, Alex Chouls"
		label info3 "pudding@onigirl.com"
	)

)--end plugin 


