-- B3d Pipeline v0.72
-- copyright 2004, Alex Chouls

plugin textureMap B3dMap 
	name:"Blitz3D Map" 
	classID:#(0x64619395, 0x4ebc41a9)
	extends:bitmapTexture
	replaceUI:true
( 
-- showProperties(bitmapTexture())

---------------------------------------
--paramblocks
---------------------------------------

	parameters main rollout:params 
	(
		b3d_map type:#bitmap --ui:btn_map
		channel type:#integer default:1 ui:channel animatable:false 
		blend type:#integer default:2 ui:blend animatable:false
		color type:#boolean default:true ui:color animatable:false
		alpha type:#boolean default:false ui:alpha animatable:false
		masked type:#boolean default:false ui:masked animatable:false
		mipmap type:#boolean default:false ui:mipmap animatable:false
		clampu type:#boolean default:false ui:clampu animatable:false
		clampv type:#boolean default:false ui:clampv animatable:false
		envmap type:#boolean default:false ui:envmap animatable:false
		vram type:#boolean default:false ui:vram animatable:false
		hicolor type:#boolean default:false ui:hicolor animatable:false
		cubic type:#boolean default:false ui:cubic animatable:false
		uoffset type:#float default:0 ui:uoffset animatable:true
		voffset type:#float default:0 ui:voffset animatable:true
		utile type:#float default:1 ui:utile animatable:true
		vtile type:#float default:1 ui:vtile animatable:true
		rotation type:#float default:0 ui:rotation animatable:true

		info type:#string default:"" --ui:info
		warnings type:#string default:""

		on uoffset set val do
		(
			delegate.coordinates.U_Offset = val
			if (uoffset.controller != undefined) then
			delegate.coordinates.U_Offset.controller = uoffset.controller
		)
		on voffset set val do 
		(
			delegate.coordinates.V_Offset = val
			if (voffset.controller != undefined) then
			delegate.coordinates.V_Offset.controller = voffset.controller
		)
		on utile set val do 
		(
			delegate.coordinates.U_Tiling = val
			if (utile.controller != undefined) then
			delegate.coordinates.U_Tiling.controller = utile.controller
		)
		on vtile set val do
		(
			delegate.coordinates.V_Tiling = val
			if (vtile.controller != undefined) then
			delegate.coordinates.V_Tiling.controller = vtile.controller
		)
		on rotation set val do 
		(
			delegate.coordinates.W_Angle = val
			if (rotation.controller != undefined) then
			delegate.coordinates.W_Angle = rotation.controller
		)
		on clampu set val do delegate.coordinates.U_Tile = not val
		on clampv set val do delegate.coordinates.V_Tile = not val
		on channel set val do delegate.coordinates.mapChannel = val
	)

/*	
	on create do
	(
		bmap = selectbitmap()
		if (bmap != undefined) then
		(	
			delegate.bitmap = bmap
			b3d_map = bmap
			delegate.filename = b3d_map.filename
		)
		--print delegate.filename
	)
*/
---------------------------------------
--rollouts
--------------------------------------
 
	rollout params "Blitz3d Texture Map" 
	( 
		--local bmap
		--local slength
		
		label lbl "Bitmap:" pos:[8,22] width:38 height:19
		button btn_map "None" pos:[47,19] width:270 height:20
		spinner channel "Map Channel:" type:#integer pos:[260,48] width:54 height:16 range:[1,2,1] scale:1
		button btn_reload "Reload" pos:[25,45] width:55 height:20 toolTip:""
		button btn_strip "Strip Path" pos:[84,45] height:20 visible:false
		
		groupBox grp3 "Blend" pos:[9,75] width:88 height:111
		radioButtons blend "" pos:[20,98] width:58 height:48 labels:#("Alpha", "Multiply", "Add", "Dot3", "Multiply 2") default:1 columns:1
		
		groupBox grp4 "Flags" pos:[106,75] width:211 height:111
		checkbox color "Color" pos:[120,98] width:77 height:15
		checkbox alpha "Alpha" pos:[214,98] width:77 height:15
		checkbox masked "Masked" pos:[120,118] width:77 height:15
		checkbox mipmap "Mipmap" pos:[214,118] width:77 height:15
		checkbox envmap "Env map" pos:[120,138] width:77 height:15
		checkbox cubic "Cube map" pos:[214,138] width:77 height:15
		checkbox vram "Vidmem" pos:[214,158] width:77 height:15
		checkbox hicolor "Hi-color" pos:[120,158] width:77 height:15
		
		groupBox coords "Coordinates" pos:[9,195] width:309 height:100
		spinner uoffset "" pos:[44,230] width:60 height:16 range:[-100,100,0]
		spinner voffset "" pos:[44,250] width:60 height:16 range:[-100,100,0]
		spinner utile "" pos:[119,230] width:60 height:16 range:[0,99999,0]
		spinner vtile "" pos:[119,250] width:60 height:16 range:[0,99999,0]
		label lbl1 "Offset" pos:[54,215] width:40 height:15
		label lbl2 "Tiling" pos:[129,215] width:40 height:15
		label lbl3 "U:" pos:[25,230] width:13 height:15
		label lbl4 "V:" pos:[25,250] width:13 height:15
		checkbox clampu "" pos:[200,230] width:15 height:15
		checkbox clampv "" pos:[200,250] width:15 height:15
		label lbl5 "Clamp" pos:[190,215] width:40 height:15
		spinner rotation "" pos:[240,230] width:60 height:16 range:[-99999,99999,0]
		label lbl6 "Rotation" pos:[245,215] width:50 height:15
		button btn_curves "Edit Curves" pos:[235,265] width:74 height:20 toolTip:""

		--groupBox sprite "Animation Frames" pos:[9,305] width:309 height:100

		button btn_view "View Image" pos:[14,305] width:74 height:20 toolTip:""
		button btn_edit "Edit Image" pos:[216,305] height:20
		button btn_pickeditor "..." pos:[288,305] height:20

		groupBox mapInfo "Map Info" pos:[9,335] width:309 height:200
		label lblInfo "" pos:[18,355] width:280 height:170

		fn buttonFit val = 
		(
			size = GetTextExtent val
			w = size.x
			txt = val
			while (w > 260) do
			(
				txt = substring txt 2 -1
				size = GetTextExtent txt
				w = size.x
			)
			txt
		)

		fn UpdateMap =
		(
			-- Reset working dir to allow for relative paths
			--sTmp = maxFilePath as string
			--if sTmp != "" then sysInfo.currentDir = sTmp
			-- init
			warnings = ""
			btn_view.enabled = true
			btn_edit.enabled = true
			-- file
			f = delegate.filename
			if (f !="") then
			(
				try(btn_map.caption = buttonFit(f))
				catch(btn_map.caption = "None")
				if (doesFileExist f == false) then
				(
					lblInfo.text = "WARNING: Invalid Path\n"
					btn_edit.enabled = false
					--btn_view.enabled = false
				)
				else
				(
					bmap = delegate.bitmap
					if (bmap != undefined) then
					(	
						-- Warnings
						w = delegate.bitmap.width
						h = delegate.bitmap.height
						if (cubic.checked == true) then
						(
							if (w != 6 * h) then \
								warnings = warnings + "WARNING: Cube map Width should be 6 * Height\n"
						)
						else
						(
							if ((bit.and (w) (w-1))>0) then \
								 warnings = warnings + "WARNING: Width Not Power of 2\n"
						)
						if ((bit.and (h) (h-1))>0) then \
							 warnings = warnings + "WARNING: Height Not Power of 2\n"
							
						-- Info
						info = "Size: "+ bmap.width as string + " x " + bmap.height as string \
						lblInfo.text = info + "\n\n" + warnings
					)
					else
					(
						--btn_view.enabled = false
						btn_edit.enabled = false
					)
				)
			)
			else
			(
				btn_map.caption = "None"
			)
		)

		on cubic changed val do UpdateMap()
			
		fn pickEditor = 
		(
			exe = ""
			plugcfgPath = GetDir #plugcfg
			iniFile = plugcfgPath +"\\B3dPipeline.ini"
			f = getINISetting iniFile "General" "MapEditor"
			exe = getOpenFileName caption:"Pick Image Editor" filename:f types:"Image Editors (*.exe)|*.exe|All (*.*)|*.*|"
			if (exe != undefined) then setINISetting iniFile "General" "MapEditor" exe
			exe
		)
	
		on btn_pickeditor pressed do
		( 
			pickEditor()
		)

		on btn_edit pressed do
		(
			plugcfgPath = GetDir #plugcfg
			iniFile = plugcfgPath +"\\B3dPipeline.ini"
			exe = getINISetting iniFile "General" "MapEditor"
			if (exe == "") then exe = pickEditor() 
			if (exe != "") then
			(
				edit = true
				--close(delegate.bitmap)
				freescenebitmaps()
				f = delegate.filename
				if (getFilenamePath(f) == "") then 
				(
					if (maxFilePath == "") then
					(
						print "Invalid Relative Path! Max file has not been saved..."
						edit = false
					)
					else
					(
						f = maxFilePath + f
					)
				)
				if (doesFileExist f == true and edit == true) then ShellLaunch exe f
				else (messageBox "Invalid Path!")
				print f
			)
		)
	
		on btn_strip pressed do
		(
			try
			(
				f = filenameFromPath delegate.filename
				print f
				delegate.bitmap.filename = f
				delegate.filename = f
				delegate.reload()
				UpdateMap()
			)
			catch
			(
				print "Invalid Path: "
				print delegate.filename
			)
		)

		on btn_reload pressed do
		(
			try(if (delegate != undefined) do delegate.reload())
			catch(print"!!!")
		)
	
		on btn_view pressed do
		(
			try(if (delegate.bitmap != undefined) do display(delegate.bitmap))
			catch()
		)
		
		on btn_curves pressed do
		(
			i = medit.getActiveMtlSlot()

			title = (medit.getcurmtl()).name
			title += " Curves  "

			title += "[ Slot " + i as string
			title += " : " 
			title += (medit.getTopMtlSlot(i)).name
			title += " ]"
			--print title
			
			-- Close it if it already exists
			for t in 1 to Trackview.NumTrackViews() do
				(
				--If Trackview.GetTrackviewName T == "B3dMap Curves" then 
				If Trackview.GetTrackviewName T == title then 
					(
						--trackviews.close "B3dMap Curves"
					)
				else 
					(
					)
				)
			-- Make a new one
			TrackView.Open title
			TrackView.setFilter title #all
			TrackView.clearFilter title #modifiedObjects #selectedTracks #visibleObjects #SelectedObjects #animatedTracks --#curveX #curveY #curveZ #Objects #Hierarchy #Transforms #Position #Rotation #Scale #positionX #positionY #positionZ #rotationX #rotationY #rotationZ #scaleX #scaleY #scaleZ
			
			trackviews.currentTrackView.rootTrack = medit.getcurmtl()
			trackviews.currentTrackView.zoomOnTrack trackViewNodes 1
			trackviews.currentTrackView.expandTracks()
			
			-- Now put it into fcurve mode
			tvInterface = trackviews.getTrackView title;
			tvInterface.setEditMode #editFCurves;
			
			-- And select ALL the tracks of the type that we would want to see or select...
			if selection.count != 0 then  (
				numT = tvInterface.getNumTracks()
				didSelect = false;		-- have we done anything yet?
				for t in 1 to numT do (
					myTrack = tvInterface.getTrack t;
					theClass = classOf myTrack;
					if (theClass == Linear_Position or 	theClass == Noise_Position or 	
						theClass == Position_Reactor or theClass == TCB_Position or 	
						theClass == Bezier_Position or theClass == Bezier_Color or 
				
						theClass == Linear_Rotation or	theClass == Noise_Rotation or 	
						theClass == Rotation_Reactor or	theClass == TCB_Rotation or 
						
						theClass == Bezier_Scale or		theClass == Linear_Scale or
						theClass == Noise_Scale or 		theClass == Scale_Reactor or
						theClass == TCB_Scale or
						
						theClass == Bezier_Float or 	theClass == Float_Reactor or
						theClass == Linear_Float or 	theClass == Noise_Float or
						theClass == On_Off or 			theClass == TCB_Float or
						theClass == Waveform_Float	) then (
				
							tvInterface.selectTrackByIndex t (not didSelect);
							didSelect = true;
							)
							
					)
				)
			
		)
		
		on btn_map pressed do
		(
			--bmap = selectbitmap()
			f = getBitmapOpenFileName filename:delegate.filename
			if f!=undefined then bmap = openBitMap f
			if (bmap != undefined) then
			(	
				delegate.bitmap = bmap
				delegate.filename = bmap.filename
				UpdateMap()
				close(bmap)
			)
		)

		on params open do UpdateMap()
		on params reload do UpdateMap()

	)--end rollout 

	rollout aboutme "About" rolledUp:true
	(
		label info1 "Blitz3d Map"
		label version "B3d Pipeline v0.72"
		label info2 "Copyright 2003, Alex Chouls"
		label info3 "pudding@onigirl.com"
	)

)--end plugin 


